Send Message im.message.add

If you are developing integrations for Bitrix24 using AI tools (Codex, Claude Code, Cursor), connect to the MCP server so that the assistant can utilize the official REST documentation.

Scope: im

Who can execute the method: a user with permission to send messages in chat

The method im.message.add sends a message to a chat.

Method Parameters

Required parameters are marked with *

Name
type

Description

DIALOG_ID*
string

Identifier of the chat in the format:

  • chatXXX — chat
  • sgXXX — group or project chat
  • XXX — identifier of the personal chat user

The chat identifier can be obtained using the im.chat.get method. The user identifier can be obtained using the user.get and user.search methods

MESSAGE*
string

The text of the message. Required if ATTACH is not provided.

Formatting is supported

ATTACH
object
string

Attachment with content blocks: images, links, files. Required if MESSAGE is not provided.

Read more in the Attachments section

KEYBOARD
object
string

Buttons under the message that the user can interact with.

Read more in the Working with Keyboards article

MENU
object
string

Additional items in the chat's context menu.

Read more in the Context Menu article

SYSTEM
string

Indicator of a system message.

Allowed values:

  • Y — system message
  • N — regular message

Default is N

URL_PREVIEW
string

Conversion of links into rich links.

Allowed values:

  • Y — enabled
  • N — disabled

Default is Y

REPLY_ID
integer

Identifier of the message to which the reply is sent. The message for the reply must be in the same chat.

The identifier can be obtained using the im.dialog.messages.get method

Code Examples

How to Use Examples in Documentation

curl -X POST \
        -H "Content-Type: application/json" \
        -H "Accept: application/json" \
        -d '{"DIALOG_ID":"chat2941","MESSAGE":"Message text","SYSTEM":"N","URL_PREVIEW":"Y","REPLY_ID":34237}' \
        https://**put_your_bitrix24_address**/rest/**put_your_user_id_here**/**put_your_webhook_here**/im.message.add
        
curl -X POST \
        -H "Content-Type: application/json" \
        -H "Accept: application/json" \
        -d '{"DIALOG_ID":"chat2941","MESSAGE":"Message text","SYSTEM":"N","URL_PREVIEW":"Y","REPLY_ID":34237,"auth":"**put_access_token_here**"}' \
        https://**put_your_bitrix24_address**/rest/im.message.add
        
try
        {
            const response = await $b24.callMethod(
                'im.message.add',
                {
                    DIALOG_ID: 'chat2941',
                    MESSAGE: 'Message text',
                    SYSTEM: 'N',
                    URL_PREVIEW: 'Y',
                    REPLY_ID: 34237
                }
            );
            
            const result = response.getData().result;
            console.log('Created message with ID:', result);
            processResult(result);
        }
        catch( error )
        {
            console.error('Error:', error);
        }
        
try {
            $response = $b24Service
                ->core
                ->call(
                    'im.message.add',
                    [
                        'DIALOG_ID' => 'chat2941',
                        'MESSAGE' => 'Message text',
                        'SYSTEM' => 'N',
                        'URL_PREVIEW' => 'Y',
                        'REPLY_ID' => 34237
                    ]
                );
        
            $result = $response
                ->getResponseData()
                ->getResult();
        
            echo 'Success: ' . print_r($result, true);
            processData($result);
        
        } catch (Throwable $e) {
            error_log($e->getMessage());
            echo 'Error adding message: ' . $e->getMessage();
        }
        
BX24.callMethod(
            'im.message.add',
            {
                DIALOG_ID: 'chat2941',
                MESSAGE: 'Message text',
                SYSTEM: 'N',
                URL_PREVIEW: 'Y',
                REPLY_ID: 34237
            },
            function(result)
            {
                if (result.error())
                    console.error(result.error());
                else
                    console.log(result.data());
            }
        );
        
require_once('crest.php');
        
        $result = CRest::call(
            'im.message.add',
            [
                'DIALOG_ID' => 'chat2941',
                'MESSAGE' => 'Message text',
                'SYSTEM' => 'N',
                'URL_PREVIEW' => 'Y',
                'REPLY_ID' => 34237
            ]
        );
        
        echo '<PRE>';
        print_r($result);
        echo '</PRE>';
        

Response Handling

HTTP Status: 200

{
            "result": 34239,
            "time": {
                "start": 1772552939,
                "finish": 1772552939.091396,
                "duration": 0.09139609336853027,
                "processing": 0,
                "date_start": "2026-03-03T17:48:59+01:00",
                "date_finish": "2026-03-03T17:48:59+01:00",
                "operating_reset_at": 1772553539,
                "operating": 0
            }
        }
        

Returned Data

Name
type

Description

result
integer

Identifier of the sent message

time
time

Information about the request execution time

Error Handling

HTTP Status: 400

{
            "error": "MESSAGE_EMPTY",
            "error_description": "Message can't be empty"
        }
        

Name
type

Description

error
string

String error code. It may consist of digits, Latin letters, and underscores

error_description
error_description

Textual description of the error. The description is not intended to be shown to the end user in its raw form

Possible Error Codes

Code

Description

Value

MESSAGE_EMPTY

Message can't be empty

Empty MESSAGE and ATTACH not provided

USER_ID_EMPTY

User ID can't be empty

User identifier in DIALOG_ID is not provided or is invalid

USER_NOT_FOUND

User not found

User not found

CHAT_ID

Error creating message

Failed to create message. Ensure that a chat with such ID exists

ACCESS_ERROR

Action unavailable

Insufficient permissions to send the message

PARAMS_ERROR

Incorrect params

Invalid set of request parameters

ATTACH_ERROR

Incorrect attach params

Invalid ATTACH object

ATTACH_OVERSIZE

You have exceeded the maximum allowable size of attach

The size of ATTACH exceeds the allowable limit

KEYBOARD_ERROR

Incorrect keyboard params

Invalid KEYBOARD object

MENU_ERROR

Incorrect menu params

Invalid MENU object

REPLY_ACCESS_ERROR

Action unavailable

No access to the message in REPLY_ID

REPLY_FROM_OTHER_CHAT_ERROR

You can only reply to a message within the same chat

Cannot reply to a message from another chat

Statuses and System Error Codes

HTTP Status: 20x, 40x, 50x

The errors described below may occur when calling any method.

Status

Code
Error Message

Description

500

INTERNAL_SERVER_ERROR
Internal server error

An internal server error has occurred. Please contact the server administrator or Bitrix24 technical support

500

ERROR_UNEXPECTED_ANSWER
Server returned an unexpected response

An internal server error has occurred. Please contact the server administrator or Bitrix24 technical support

503

QUERY_LIMIT_EXCEEDED
Too many requests

The request intensity limit has been exceeded

405

ERROR_BATCH_METHOD_NOT_ALLOWED
Method is not allowed for batch usage

The current method is not permitted for calls using batch

400

ERROR_BATCH_LENGTH_EXCEEDED
Max batch length exceeded

The maximum length of parameters passed to the batch method has been exceeded

401

NO_AUTH_FOUND
Wrong authorization data

Invalid access token or webhook code

400

INVALID_REQUEST
Https required

The HTTPS protocol is required for method calls

503

OVERLOAD_LIMIT
REST API is blocked due to overload

The REST API is blocked due to overload. This is a manual individual block; please contact Bitrix24 technical support to lift it

403

ACCESS_DENIED
REST API is available only on commercial plans

The REST API is only available on commercial plans

403

INVALID_CREDENTIALS
Invalid request credentials

The user associated with the access token or webhook used to call the method lacks the necessary permissions

404

ERROR_MANIFEST_IS_NOT_AVAILABLE
Manifest is not available

The manifest is not available

403

insufficient_scope
The request requires higher privileges than provided by the webhook token

The request requires higher privileges than those provided by the webhook token

401

expired_token
The access token provided has expired

The provided access token has expired

403

user_access_error
The user does not have access to the application

The user does not have access to the application. This means that the application is installed, but the portal administrator has restricted access to this application to specific users only

500

PORTAL_DELETED
Portal was deleted

The public part of the site is closed. To open the public part of the site on an on-premise installation, disable the "Temporary closure of the public part of the site" option. Path to the setting: Desktop > Settings > Product Settings > Module Settings > Main Module > Temporary closure of the public part of the site

Continue Learning